<?PHP

######################################################################
# PHP-NUKE: Web Portal System
# ===========================
#
# Copyright (c) 2000 by Francisco Burzi (fburzi@ncc.org.ve)
# http://www.ncc.org.ve/php-nuke.php3
#
# This modules is to configure the main options for your site
#
# This program is free software. You can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
######################################################################

##########################################
# Database Config                        #
##########################################

$dbhost = "localhost";  # Mysql Database host
$dbuname = "root";	# Mysql user
$dbpass = "";		# Mysql password
$dbname = "nuke";	# Mysql Database name

##########################################
# Site Identification Config             #
##########################################

$sitename = "Linux Preview"; 			# Your site name
$nuke_url = "http://yoursite.com"; 		# ex: http://yoursite.com  - for root dir (NO SLASH ON END)
$titletag = "Write here your site's slogan..."; # might be phased out
$titlebar = "Write here your site's slogan..."; # for theme title bars; can contain HTML
$startdate = "July 2.000";			# Your site's start date
$adminmail = "webmaster@yourdomain.com"; 	# Main Administrator/Webmaster E-mail address
$top = "10";  					# How many items in the TOP page would you have?
$oldnum = "20";					# How many stories in Past Articles box
$ultramode = "0";				# Generate ultramode.txt headlines file? 1=yes 0=no (need chmod 777 of your main web directory)

##########################################
# Banners / Advertising Config           #
##########################################

$banners = "1";			# 1 if you want banners ads in your site, otherwise 0
$myIP = "150.10.10.10";		# Your IP for NOT count banners impressions (be fair)

##########################################
# Footer Messages for each page          #
##########################################

$foot1 = "<a href=php-nuke.php3><img src=images/powered/phpnuke.gif border=0 Alt=\"Web site powered by PHP-Nuke\"></a><br>";
$foot2 = "All logos and trademarks in this site are property of their respective owner. The comments are property of their posters, all the rest  2000 by me";
$foot3 = "This web site was made with <a href=http://linuxpreview.org/php-nuke.php3>PHP-Nuke</a>, a web portal system written in PHP. PHP-Nuke is Free Software released under the <a href=http://www.gnu.org>GNU/GPL license</a>.";
$foot4 = "You can syndicate our news using the file <a href=backend.php3>Backend.php3</a>";

##########################################
# Backend / Headlines Config             #
##########################################

$backend_title = "Your site Name - Your slogan";	# Title for backend.php3; NO HTML
$backend_language = "es-ve";				# Backend text language
$backend_image = "$nuke_url/images/mynetscape.gif";	# Image for your channel
$backend_width = "88";					# Image width
$backend_height = "31";					# Image height

##########################################
# Language Config                        #
##########################################

$language = "english";   # Language module (valid options are: english, spanish, french, german, italian, danish, swedish, portuguese, russian, dutch, traditionalchinese, simplifiedchinese) in lowercase
$locale = "en_US";	 # Locale time format (look at "/usr/share/locale" with this you can have date and time in your language!)

##########################################
# Web Links Config		         #
##########################################

$perpage = 10;		# How many links per page you want to display
$popular = 100;		# How many Hits to be a Popular Site
$newlinks = 10;		# How many links to display as a new links
$toplinks = 10;		# How many links in the best
$linksresults = 10;	# How many links in search results page

##########################################
# Mail New Stories to Admin              #
##########################################

$notify = 0; # 1 to receive an email when news is submitted through submit.php3
             # 0 not to receive email
             # notify will not work with Windows unless php properly configured
$notify_email = "me@yourdomain.com"; #address where you want to receive notice
$notify_subject = "NEWS for $sitename";
$notify_message = "You have a new news submission titled $subject\n---\n$story";
$notify_from = "webmaster"; # server email account

##########################################
# Moderation Config (not working yet)    #
##########################################

$moderate = 1; # 1 for comment moderation by admin
               # 2 for moderation by anyone
	       # 0 for no moderation

$reasons = array('As Is', 	# "Normal"
		'Offtopic', 	# Bad Responses
		'Flamebait',
		'Troll',
		'Redundant',
		'Insightful', 	# Good Responses
		'Interesting',
		'Informative',
		'Funny',
		'Overrated',	# Last two are "special"
		'Underrated');
$badreasons = 4; # number of "Bad" reasons in $reasons, skip 0 (which is neutral)

##########################################
# Some Comments Options                  #
##########################################

$commentlimit = 4096; 		# Max displayed size of comments in bytes (over will make read more link)
$anonymous = "Anonymous";	# Anonimous user's default name

##########################################
# Filters Options (not working yet)      #
##########################################

$MaxTextLength   = 0;     # Maximum # of displayable characters, ignoring HTML
$MaxTotalLength  = 0;     # Max # of characters total
$CensorList   = array('fuck','cunt','fucker','fucking','pussy','cock','c0ck','cum','twat','clit','bitch','fuk','fuking','motherfucker');
$CensorMode   = 1;        # 0: no filtering
			  # 1: exact match
                    	  # 2: match word beginnings
                          # 3: match string anywhere in words
$CensorReplace   =  '*';  # Character to replace the bad words in $Censorlist

##########################################
# Some Comments Options                  #
##########################################

$AllowableHTML = array("p"=>2,   # 2 means accept all qualifiers: <foo bar>
                      "b"=>1,    # 1 means accept the tag only: <foo>
                      "i"=>1,
                      "a"=>2,
                      "em"=>1,
                      "br"=>1,
                      "strong"=>1,
                      "blockquote"=>1,
                      "tt"=>1,
                      "li"=>1,
                      "ol"=>1,
		      "div"=>2,
                      "ul"=>1);

##########################################
# Voting Booth Options                   #
##########################################

$maxOptions = "12";	# maximal number of options allowed
$BarScale = "1";	# scale of result bar (in multiples of 100 pixels)
$setCookies = "1";	# 1 - not allowing a user to vote twice for the same poll
			# 0 - does not set a cookie nor does it check for one

##########################################
# Images and Fonts for Dynamic Pages     #
##########################################

$tipath = "images/topics/";			# Path to the Topics images directory 
$userimg = "images/menu/";			# Location for the Users images
$adminimg = "images/menu/admin/";		# Location for the Admin images
$admingraphic = "0";				# 1 = Graphical Administration
						# 0 = Text Administration
$font1 = "<font face=Arial,Helvetica size=1>";	# Default font with size of 1
$font2 = "<font face=Arial,Helvetica size=2>";	# Default font with size of 2
$font3 = "<font face=Arial,Helvetica size=3>";	# Default font with size of 3
$font4 = "<font face=Arial,Helvetica size=4>";	# Default font with size of 4

##########################################
# Other Misc System Options              #
##########################################

$system = "0"; 			# use 0 for Unix/Linux (tested!) and 1 for others like Windows (not tested!)
$admart = "20";			# How many articles to display in admin section?
$minpass = "5";			# Minimum user password length in charachters
$httpref = "1";			# 1 to save referers, otherwise 0
$pollcomm = "1";		# Comments in Polls? 1=yes 0=no

##########################################
# Cookies Configuration                  #
##########################################

$cookieadmtime = "2592000";	# Number of seconds to the Admin cookie to expire
$cookiePrefix = "NukePoll";	# Prefix for cookie name

##########################################
# Do NOT touch the Following Options     #
##########################################

$uimages = "$userimg$language";

?>