<?php

######################################################################
# PHP-NUKE: Web Portal System
# ===========================
#
# Copyright (c) 2000 by Francisco Burzi (fburzi@ncc.org.ve)
# http://www.ncc.org.ve/php-nuke.php3
#
# This modules is a collection of some usefull global functions
#
# This program is free software. You can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
######################################################################

include("config.php3");
include("lang-$language.php3");
$mainfile = 1;

function dbconnect() {
	include("config.php3");
	mysql_pconnect($dbhost, $dbuname, $dbpass);
	@mysql_select_db("$dbname") or die ("Unable to select database");
}

function ultramode() {
    $file = fopen("ultramode.txt", "w");
    fwrite($file, "General purpose self-explanatory file with news headlines\n");
    $rfile=mysql_query("select sid, aid, title, time, comments, topic from stories order by time DESC limit 0,10");
    while(list($sid, $aid, $title, $time, $comments, $topic) = mysql_fetch_row($rfile)) {
	$rfile2=mysql_query("select topictext, topicimage from topics where topicid=$topic");
	list($topictext, $topicimage) = mysql_fetch_row($rfile2);
	$content = "%%\n$title\n/article.php3?sid=$sid\n$time\n$aid\n$topictext\n$comments\n$topicimage\n";
	fwrite($file, $content);
    }
    fclose($file);
}

function counter() {
	dbconnect();
	mysql_query("UPDATE vars SET value=value+1 where name='totalhits'");
}

function cookiedecode($user) {
	global $cookie;
	$user = base64_decode($user);
	$cookie = explode(":", $user);
	return $cookie;
}

function getusrinfo($user) {
	global $userinfo;
	$user2 = base64_decode($user);
	dbconnect();
	$user3 = explode(":", $user2);
	$result = mysql_query("select uid, name, uname, email, femail, url, pass, storynum, umode, uorder, thold, noscore, bio, ublockon, ublock, theme, commentmax from users where uname='$user3[1]' and pass='$user3[2]'");
	if(mysql_num_rows($result)==1) {
		$userinfo = mysql_fetch_array($result);
	} else {
		echo "<b>A problem occured</b><br>";
	}
	return $userinfo;
}

function FixQuotes ($what = "") {
	$what = ereg_replace("'","''",$what);
	while (eregi("\\\\'", $what)) {
		$what = ereg_replace("\\\\'","'",$what);
	}
	return $what;
}

/*********************************************************/
/* text filter                                           */
/*********************************************************/

function check_words($Message) {
	global $EditedMessage, $CensorList, $CensorMode, $CensorReplace;
	$EditedMessage = $Message;

	if ($CensorMode != 0) {
		if (is_array($CensorList)) {
			$Replacement = $CensorReplace;

			if ($CensorMode == 1) { # Exact match
				$RegExPrefix   = '([^[:alpha:]]|^)';
				$RegExSuffix   = '([^[:alpha:]]|$)';
			} elseif ($CensorMode == 2) {    # Word beginning
				$RegExPrefix   = '([^[:alpha:]]|^)';
				$RegExSuffix   = '[[:alpha:]]*([^[:alpha:]]|$)';
			} elseif ($CensorMode == 3) {    # Word fragment
				$RegExPrefix   = '([^[:alpha:]]*)[[:alpha:]]*';
				$RegExSuffix   = '[[:alpha:]]*([^[:alpha:]]*)';
			}

			for ($i = 0; $i < count($CensorList) && $RegExPrefix != ''; $i++) {
				$EditedMessage = eregi_replace($RegExPrefix.$CensorList[$i].$RegExSuffix,"\\1$Replacement\\2",$EditedMessage);
			}
		}
	}
	return ($EditedMessage);
}

function check_html ($str, $strip="") {

    include("config.php3");

    if ($strip == "nohtml")
	$AllowableHTML=array('');

    $str = stripslashes($str);
    $str = eregi_replace("<[[:space:]]*([^>]*)[[:space:]]*>","<\\1>",$str);
    $tmp = "";
    while (eregi("<([^> ]*)([^>]*)>",$str,$reg)) {
      $i = strpos($str,$reg[0]);
      $l = strlen($reg[0]);
      if ($reg[1][0] == "/") $tag = strtolower(substr($reg[1],1));
      else $tag = strtolower($reg[1]);	
      if ($a = $AllowableHTML[$tag])
        if ($reg[1][0] == "/") $tag = "</$tag>";
        elseif ($a == 1) $tag = "<$tag>";
        else $tag = "<$tag " . $reg[2] . ">";
      else $tag = "";
      $tmp .= substr($str,0,$i) . $tag;
      $str = substr($str,$i+$l);
    }
    $str = $tmp . $str;

    // Squash PHP tags unconditionally
    $str = ereg_replace("<\?","",$str);
    $str = ereg_replace("\"","",$str); 
    return $str;
}

function filter_text($Message, $strip="") {
	global $EditedMessage;
	check_words($Message);
	$EditedMessage=check_html($EditedMessage, $strip);
	return ($EditedMessage);
}

/*********************************************************/
/* formatting stories                                    */
/*********************************************************/

function formatTimestamp($time) {
	include ("config.php3");
	global $datetime;
	setlocale ("LC_TIME", "$locale");
	ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
	$datetime = strftime("".translate("datestring")."", mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]));
	$datetime = ucfirst($datetime);
	return($datetime);
}

function formatAidHeader($aid) {
	$holder = mysql_query("SELECT url, email FROM authors where aid='$aid'");
	if (!$holder) { echo mysql_errno(). ": ".mysql_error(). "<br>";	exit(); }
	list($url, $email) = mysql_fetch_row($holder);
	if (isset($url)) { echo "<a href=\"$url\">$aid</a>";
	} elseif (isset($email)) { echo "<a href=\"mailto:$email\">$aid</a>";
	} else { echo $aid; }
}

function oldNews($storynum) {
	include ("config.php3");
	$boxstuff = "<font face=Arial,Helvetica size=2>";
	$boxTitle = translate("Past Articles");
	$result = mysql_query("select sid, title, time, comments from stories order by time desc limit $storynum, $oldnum");
	while(list($sid, $title, $time, $comments) = mysql_fetch_row($result)) {
	    setlocale ("LC_TIME", "$locale");
	    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime2);
	    $datetime2 = strftime("".translate("datestring2")."", mktime($datetime2[4],$datetime2[5],$datetime2[6],$datetime2[2],$datetime2[3],$datetime2[1]));
	    $datetime2 = ucfirst($datetime2);
	    if($time2==$datetime2) {
		$boxstuff .= "<li><a href=\"article.php3?sid=$sid\">$title</a> ($comments)";
	    } else {
		if($a=="") {
		    $boxstuff .= "$datetime2<br><br><li><a href=\"article.php3?sid=$sid\">$title</a> ($comments)";
		    $time2 = $datetime2;
		    $a = 1;
		} else {
		    $boxstuff .= "<br><br>$datetime2<br><br><li><a href=\"article.php3?sid=$sid\">$title</a> ($comments)";
		    $time2 = $datetime2;
		}
	    }
	    
	}
	themesidebox($boxTitle, $boxstuff);
}

function mainblock() {
//	dbconnect();
	$result = mysql_query("select title, content from mainblock");
	while(list($title, $content) = mysql_fetch_array($result)) {
		$content = nl2br($content);
		themesidebox($title, $content);
	}
}

function rightblocks() {
	$result = mysql_query("select title, content from rblocks");
	while(list($title, $content) = mysql_fetch_array($result)) {
		$content = nl2br($content);
		themesidebox($title, $content);
	}
}

function leftblocks() {
	$result = mysql_query("select title, content from lblocks");
	while(list($title, $content) = mysql_fetch_array($result)) {
		$content = nl2br($content);
		themesidebox($title, $content);
	}
}

function adminblock() {
	$result = mysql_query("select title, content from adminblock");
	while(list($title, $content) = mysql_fetch_array($result)) {
		$content = nl2br($content);
		themesidebox($title, $content);
	}
}


/*********************************************************/
/* poll functions                                        */
/*********************************************************/

function pollMain($pollID) {
	global $maxOptions, $boxTitle, $boxContent, $uimages;
	include("config.php3");
	dbconnect();
	if(!isset($pollID))
	  $pollID = 1;
	if(!isset($url))
	  $url = sprintf("pollBooth.php3?op=results&pollID=%d", $pollID);

	$boxContent .= "<form action=\"pollBooth.php3\" method=\"post\">";
	$boxContent .= "<input type=\"hidden\" name=\"pollID\" value=\"".$pollID."\">";
	$boxContent .= "<input type=\"hidden\" name=\"forwarder\" value=\"".$url."\">";
	$result = mysql_query("SELECT pollTitle, voters FROM poll_desc WHERE pollID=$pollID");
	list($pollTitle, $voters) = mysql_fetch_row($result);
	$boxTitle = translate("Survey");
	$boxContent .= "<font face=Arial,Helvetica size=2><b>$pollTitle</b><br>";
	for($i = 1; $i <= $maxOptions; $i++) {
		$result = mysql_query("SELECT pollID, optionText, optionCount, voteID FROM poll_data WHERE (pollID=$pollID) AND (voteID=$i)");
		$object = mysql_fetch_object($result);
		if(is_object($object)) {
			$optionText = $object->optionText;
			if($optionText != "") {
				$boxContent .= "<input type=\"radio\" name=\"voteID\" value=\"".$i."\"><font face=Arial,Helvetica size=2> $optionText <br>";
			}
		}
	}

	$boxContent .= "<center><table cellspacing=0 cellpadding=5 border=0 width=111><tr><td align=center> <input type=image src=$uimages/vote.gif border=0></td><td align=center></form>";
	$boxContent .= "<a href=\"pollBooth.php3?op=results&pollID=$pollID\"><img src=$uimages/result.gif border=0></a></td></tr></table><a href=\"pollBooth.php3\"><b>".translate("Past Surveys")."</a></b><br>";
	if ($pollcomm) {
	    list($numcom) = mysql_fetch_row(mysql_query("select count(*) from pollcomments where pollID=$pollID"));
	    $boxContent .= "<br>".translate("Votes: ")."<b>$voters</b> | ".translate("comments:")."  <b>$numcom</b>";
	} else {
	    $boxContent .= "<br>".translate("Votes: ")."<b>$voters</b>";
	}
	$boxContent .= "</font></center>";
	themesidebox($boxTitle, $boxContent);
}

function pollLatest() {
	dbconnect();
	$result = mysql_query("SELECT pollID FROM poll_data ORDER BY pollID DESC");
	$pollID = mysql_fetch_row($result);
	return($pollID[0]);
}

function pollNewest() {
	$pollID = pollLatest();
	pollMain($pollID);
}

function pollCollector($pollID, $voteID, $forwarder) {
	global $maxOptions, $setCookies, $cookiePrefix, $HTTP_COOKIE_VARS;
	dbconnect();
	$voteValid = "1";

	if($setCookies>0) {
		// we have to check for cookies, so get timestamp of this poll
		$result = mysql_query("SELECT timeStamp FROM poll_desc WHERE pollID=$pollID");
		$object = mysql_fetch_object($result);
		$timeStamp = $object->timeStamp;
		$cookieName = $cookiePrefix.$timeStamp;

		// check if cookie exists
		if($HTTP_COOKIE_VARS["$cookieName"] == "1") {
			// cookie exists, invalidate this vote
			$warn = "You already voted today!";
			$voteValid = "0";
		} else {
			// cookie does not exist yet, set one now
			$cvalue = "1";
			setcookie("$cookieName",$cvalue,time()+86400);
		}
	}

	// update database if the vote is valid
	if($voteValid>0) {
		@mysql_query("UPDATE poll_data SET optionCount=optionCount+1 WHERE (pollID=$pollID) AND (voteID=$voteID)");
		@mysql_query("UPDATE poll_desc SET voters=voters+1 WHERE pollID=$pollID");
		Header("Location: $forwarder");
	} else {
		Header("Location: $forwarder");
	}
	// a lot of browsers can't handle it if there's an empty page
	echo "<html><head></head><body></body></html>";
}

function pollList() {
	dbconnect();
	$result = mysql_query("SELECT pollID, pollTitle, timeStamp, voters FROM poll_desc ORDER BY timeStamp"); 
	$counter = 0;
	echo "<table border=0 cellpadding=8><tr><td>";
	echo "<font face=Arial,Helvetica size=3>";
	while($object = mysql_fetch_object($result)) {
		$resultArray[$counter] = array($object->pollID, $object->pollTitle, $object->timeStamp, $object->voters);
		$counter++;
	}
	for ($count = 0; $count < count($resultArray); $count++) {
		$id = $resultArray[$count][0];
		$pollTitle = $resultArray[$count][1];
		$voters = $resultArray[$count][3];
		echo("<li> <a href=\"pollBooth.php3?pollID=$id\">$pollTitle</a> ");
		echo("(<a href=\"pollBooth.php3?op=results&pollID=$id\">".translate("Results")."</a> - $voters ".translate("votes").")\n");
	}
	echo "</td></tr></table>";
}

function pollResults($pollID) {
	global $maxOptions, $BarScale, $resultTableBgColor, $resultBarFile, $setCookies;
	if(!isset($pollID)) $pollID = 1;
	dbconnect();

	$result = mysql_query("SELECT pollID, pollTitle, timeStamp FROM poll_desc WHERE pollID=$pollID");
	$holdtitle = mysql_fetch_row($result);
	echo "<br><b>$holdtitle[1]</b><br><br>";
	
	mysql_free_result($result);

	$result = mysql_query("SELECT SUM(optionCount) AS SUM FROM poll_data WHERE pollID=$pollID");
	$sum = (int)mysql_result($result, 0, "SUM"); 
	mysql_free_result($result);

	echo "<table>";

	// cycle through all options
	for($i = 1; $i <= $maxOptions; $i++) {
		// select next vote option
		$result = mysql_query("SELECT pollID, optionText, optionCount, voteID FROM poll_data WHERE (pollID=$pollID) AND (voteID=$i)");
		$object = mysql_fetch_object($result);

		if(is_object($object)) {
			$optionText = $object->optionText;
			$optionCount = $object->optionCount;

			echo "<tr>";

			if($optionText != "") {
				echo "<td>";
				echo "<font face=Arial,Helvetica>$optionText";
				echo "</td>";

				if($sum) {
					$percent = 100 * $optionCount * $BarScale / $sum;
				} else {
					$percent = 0;
				}
				echo "<td>";
				$percentInt = (int)$percent * 4;
				$percent2 = (int)$percent;

				if ($percent > 0) {
					echo "<img src=\"images/leftbar.gif\" height=16 width=3>";
					echo "<img src=\"images/mainbar.gif\" height=16 width=$percentInt Alt=\"$percent2 %\">";
					echo "<img src=\"images/rightbar.gif\" height=16 width=3>";
				} else {
					echo "<img src=\"images/leftbar.gif\" height=16 width=3 Alt=\"$percent2 %\">";
					echo "<img src=\"images/mainbar.gif\" height=16 width=2 Alt=\"$percent2 %\">";
					echo "<img src=\"images/rightbar.gif\" height=16 width=3 Alt=\"$percent2 %\">";
				}

                                printf(" %.2f %% (%d)", $percent, $optionCount);

				echo "</td>";
		        }
		}
		echo "</tr>";
	}

	echo "</td></tr></table><br>";
	echo "<center><font face=Arial,Helvetica><b>".translate("Total Votes: ")."$sum</b><br>";
	if($setCookies>0) {
	    echo "<font size=1>".translate("We allow just one vote per day")."<br><br><font size=3>";
	} else {
	    echo "<br><br>";
	}

	$booth = $pollID;
	echo("<font face=Arial,Helvetica>[ <a href=\"pollBooth.php3?pollID=$booth\">".translate("Voting Booth")."</a> | ");
	echo("<a href=\"pollBooth.php3\">".translate("Other Polls")."</a> ]");
	return(1);
}

function getTopics($s_sid) {
    global $topicname, $topicimage, $topictext;
    $sid = $s_sid;
    dbconnect();
    $result=mysql_query("SELECT topic FROM stories where sid=$sid");
    list($topic) = mysql_fetch_row($result);
    $result=mysql_query("SELECT topicid, topicname, topicimage, topictext FROM topics where topicid=$topic");
    list($topicid, $topicname, $topicimage, $topictext) = mysql_fetch_row($result);
}


?>
